<form>
  <mat-card>
    <mat-card-header>
      <mat-card-title class="green-text"> Add Employee </mat-card-title>
    </mat-card-header>
    <form [formGroup]="addForm" (ngSubmit)="onSubmit()">
      <mat-card-content>
        <div class="row p-5 mx-auto">
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Username</mat-label>
              <input matInput formControlName="username" />
              <mat-error
                *ngIf="
                  addFormData.username.errors?.required &&
                  (addFormData['username'].dirty ||
                    addFormData['username'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">First Name</mat-label>
              <input matInput formControlName="firstName" />
              <mat-error
                *ngIf="
                  addFormData.firstName.errors?.required &&
                  (addFormData['firstName'].dirty ||
                    addFormData['firstName'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Last Name</mat-label>
              <input matInput formControlName="lastName" />
              <mat-error
                *ngIf="
                  addFormData.lastName.errors?.required &&
                  (addFormData['lastName'].dirty ||
                    addFormData['lastName'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Email</mat-label>
              <input matInput formControlName="email" />
              <mat-error
                *ngIf="
                  addFormData.email.errors?.required &&
                  (addFormData['email'].dirty || addFormData['email'].touched)
                "
                >This field is required!</mat-error
              >
              <mat-error
                *ngIf="
                  addFormData.email.errors?.email &&
                  (addFormData['email'].dirty || addFormData['email'].touched)
                "
                >Invalid Email Format!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Birth Date</mat-label>
              <input
                matInput
                formControlName="birthDate"
                [matDatepickerFilter]="myFilter"
                [matDatepicker]="picker"
              />
              <mat-hint class="white-text">MM/DD/YYYY</mat-hint>
              <mat-datepicker-toggle
                matIconSuffix
                [for]="picker"
              ></mat-datepicker-toggle>
              <mat-datepicker #picker></mat-datepicker>
              <mat-error
                *ngIf="
                  addFormData.birthDate.errors?.required &&
                  (addFormData['birthDate'].dirty || addFormData['birthDate'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Basic Salary</mat-label>
              <input matInput type="number" formControlName="basicSalary" />
              <mat-error
                *ngIf="
                  addFormData.basicSalary.errors?.required &&
                  (addFormData['basicSalary'].dirty || addFormData['basicSalary'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Status</mat-label>
              <mat-select formControlName="statusControl" required>
                <mat-option>--</mat-option>
                @for (status of statuses; track status) {
                <mat-option [value]="status">{{ status.label }}</mat-option>
                }
              </mat-select>
              <mat-error
                *ngIf="
                  addFormData.statusControl.errors?.required &&
                  (addFormData['statusControl'].dirty || addFormData['statusControl'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Group</mat-label>
              <input
                #input
                type="text"
                placeholder="Pick one"
                matInput
                formControlName="groupControl"
                [matAutocomplete]="auto"
                (input)="filter()"
                (focus)="filter()"
              />
              <mat-autocomplete #auto="matAutocomplete">
                @for (option of filteredOptions; track option) {
                <mat-option [value]="option">{{ option }}</mat-option>
                }
              </mat-autocomplete>
              <mat-error
                *ngIf="
                  addFormData.groupControl.errors?.required &&
                  (addFormData['groupControl'].dirty || addFormData['groupControl'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
          <div class="col-sm-4">
            <mat-form-field>
              <mat-label class="green-text">Description</mat-label>
              <input
                matInput
                formControlName="description"
                [matDatepicker]="picker1"
              />
              <mat-hint class="white-text">MM/DD/YYYY</mat-hint>
              <mat-datepicker-toggle
                matIconSuffix
                [for]="picker1"
              ></mat-datepicker-toggle>
              <mat-datepicker #picker1></mat-datepicker>
              <mat-error
                *ngIf="
                  addFormData.description.errors?.required &&
                  (addFormData['description'].dirty || addFormData['description'].touched)
                "
                >This field is required!</mat-error
              >
            </mat-form-field>
          </div>
        </div>
      </mat-card-content>
      <mat-card-actions class="d-flex flex-row justify-content-end">
        <div class="mx-5 p-5">
          <button
            type="button"
            mat-raised-button
            color="warn"
            mat-button
            (click)="onCancel()"
          >
            Cancel
          </button>
        </div>
        <div class="p-5">
          <button
            type="submit"
            [disabled]="!addForm.valid"
            mat-raised-button
            color="accent"
            mat-button
          >
            Save
          </button>
        </div>
      </mat-card-actions>
    </form>
  </mat-card>
</form>
